# Obtener todos los archivos C y C++ que existan
# en la estructura de directorios y volcar la salida
# a un archivo temporal.
#
if [ "$1" != "do" ]; then   
 ./genmakev1.sh do > ./Makefile
 exit
fi

TMP_NAME="TMP_"$(date +%H%M%S)
TMP_NAME_CPP="CPP_"$TMP_NAME
TMP_NAME_C="C_"$TMP_NAME
FINAL_EXEC="spirits"

find . -depth -name '*.c' > $TMP_NAME
cut -c3-  $TMP_NAME > $TMP_NAME_C

find . -depth -name '*.cpp' > $TMP_NAME
cut -c3-  $TMP_NAME > $TMP_NAME_CPP

cat $TMP_NAME_CPP > $TMP_NAME
cat $TMP_NAME_C >> $TMP_NAME

echo "###################################" 
echo "# M.A Software Makefile Generator #" 
echo "###################################" 
echo 
echo "CPP = g++" 
echo "CC  = gcc" 
echo "OBJ="$( (cat $TMP_NAME | gawk '{print $1".o "}' )) 
echo "LINKOBJ="$( (cat $TMP_NAME | gawk '{print $1".o "}' )) 
echo "LIBS =  \`allegro-config --libs\` -lalfont -lz -lpng  -g3"   
echo "BIN = $FINAL_EXEC"  
echo "CXXFLAGS = -DLINUX \$(CXXINCS) -g3"  
echo "CFLAGS = \$(INCS) -g3"  
echo "RM = rm -f" 
echo 
echo ".PHONY: all all-before all-after clean clean-custom"
echo 
echo "all: all-before $FINAL_EXEC all-after" 
echo
echo "clean: clean-custom"
echo -e "\t\${RM} \$(OBJ) \$(BIN)" 
echo 
echo "\$(BIN): \$(OBJ)"
echo -e "\t\$(CPP) \$(LINKOBJ) -o \"$FINAL_EXEC\" \$(LIBS)" 
echo
cat $TMP_NAME_CPP | gawk '{print $1".o: "$1"\n\t$(CPP) -c "$1" -o "$1".o $(CXXFLAGS)\n"}' 
cat $TMP_NAME_C | gawk '{print $1".o: "$1"\n\t$(CC) -c "$1" -o "$1".o $(CFLAGS)\n"}' 

# Limpiamos los archivos temporales.
#
rm $TMP_NAME
rm $TMP_NAME_C
rm $TMP_NAME_CPP

