#ifndef _LOG_CPP_
#define _LOG_CPP_

#include "log.hpp"
#include <stdarg.h>
#include <time.h>

Log::Log()
{
	f=stdout;
	setEnabled(true);
}

Log::~Log(void)
{
    if (f!=NULL && f!=stdout) fclose(f);
}

void Log::setLogFile(const char *filename)
{
    if (!ib_enabled) return;
    
    // Obtenemos un STRING con la fecha y la hora
    //
    char datestring[100];
    time_t curtime = time(NULL);
    struct tm *loctime = localtime(&curtime);
    strftime(datestring,sizeof(datestring),"%d-%m-%y %H:%M:%S. ",loctime);

    // Inicializamos el archivo de LOG
    //
    if (f!=NULL && f!=stdout) fclose(f);
    f=fopen(filename,"at+");
	if (f==NULL) f=stdout;
	fprintf(f,_("\n\n===================================================\n"));
	fprintf(f,_("%s INICIALIZANDO SISTEMA DE LOG\n"),datestring);
	fprintf(f,_("===================================================\n\n"));
	fflush(f);
}

void Log::logMsg(const char *format, ...)
{
    if (!ib_enabled) return;
    
    // Obtenemos un STRING con la fecha y la hora
    //
    char datestring[100];
    time_t curtime = time(NULL);
    struct tm *loctime = localtime(&curtime);
    strftime(datestring,sizeof(datestring),"%d-%m-%y %H:%M:%S. ",loctime);

    // Escribimos en el LOG
    //
    va_list args;
	va_start(args, format);
    fprintf(f,datestring);
	vfprintf(f,format,args);
	fprintf(f,"\n");
	fflush(f);
	va_end(args);
}

#endif
