#ifndef _LUASPIRITS_CPP_
#define _LUASPIRITS_CPP_

#include "luaspirits.hpp"

LuaHandler::LuaHandler()
{
	ls=lua_open();
}

LuaHandler::~LuaHandler()
{
	if (ls) lua_close(ls);
}

int LuaHandler::executeFileScript(const char *filename)
{
    if (ls)
    {
        return luaL_dofile(ls,filename);
    }
    return -1;
}

void LuaHandler::reset()
{
    if (ls) lua_close(ls);
    ls=lua_open();
}

lua_State * LuaHandler::getHandler()
{
	return ls;
}

#endif
