#ifndef _PATH_HPP_
#define _PATH_HPP_

#define DFLT_DATA_DIR "data/"
#define DFLT_SCRIPTS_DIR "data/scripts/"
#define DFLT_LANG_DIR "data/lang/"

#include <unistd.h>
#include "../../masoftware/util/tmastring.hpp"

class Path
{
    private:
        TMAString current_directory;
        TMAString data_prefix;
        TMAString lang_prefix;
        TMAString config_prefix;
        TMAString scripts_prefix;

	public:

        enum FileType { FT_DATA=0, FT_CONFIG, FT_SCRIPTS, FT_LANG, FT_CURRENT };

        void init(int argc,char **argv);
        
		const TMAString& getCurrentDirectory();
		const TMAString& getDataPrefix();
		const TMAString& getLangPrefix();
		const TMAString& getConfigPrefix();
		const TMAString& getScriptsPrefix();

		TMAString makePath(const char *path, const char *file);
		TMAString makePath(const TMAString& path, const char *file);

		bool checkFile(Path::FileType ft, const char *name);
};


#endif
