#ifndef _TSPRITEHANDLE_CPP_
#define _TSPRITEHANDLE_CPP_

#include "sprites.hpp"
#include "../spirits.hpp"

REGISTER_CLASS_ID(TSpriteHandle);

TSpriteHandle::TSpriteHandle(PMAImageBank bank):TSpriteSpirits(bank)
{
    ii_Retardo=3;
    ii_CurrentFotograma = 18;
    ii_Estado = S_NORMAL;
}

bool TSpriteHandle::isPushed(void)
{
    return (ii_Estado != S_NORMAL);
}

bool TSpriteHandle::isPushedBy(PSpriteBrujo b)
{
    int bmx = b->getHotspotMapX();
    int px = position.x / 20;
    
    return (bmx >= px && bmx <= px + 1);
}

void TSpriteHandle::push(void)
{
    if (ii_Estado==S_NORMAL) ii_Estado = S_MOVE;
}

void TSpriteHandle::animate(void)
{
    switch (ii_Estado)
    {
        case S_MOVE:

            if (ii_CurrentFotograma<20)
            {
            	if (ii_RetardoPos<ii_Retardo)
            	{
            		ii_RetardoPos ++;
            	}
            	else
            	{
            		ii_RetardoPos=0;
            		ii_CurrentFotograma++;
            	}
            }
            else
            {
                ii_Estado = S_PUSHED;
            }
            break;
    }
}


bool TSpriteHandle::draw(TMABitmap& g)
{
    PMABitmap bmp = io_images->getBitmap(ii_CurrentFotograma);
    position.width = bmp->getWidth();
    position.height = bmp->getHeight();
    #ifdef SMALL_GAME
        position.width<<=1;
        position.height<<=1;
    #endif
    g.draw(bmp,position.x,position.y);
    return true;
}


#endif
