#ifndef _TSPRITEOBJECT_CPP_
#define _TSPRITEOBJECT_CPP_

#include "sprites.hpp"
#include "../spirits.hpp"

#define GETKEYDOWN(X)   myGame->inputController.isPressDown(TSpiritsGame::X)


REGISTER_CLASS_ID(TSpriteObject);

int TSpriteObject::ia_AnimSphere[4]={50,51,52,53};
int TSpriteObject::ia_AnimBook[32]={54,55,56,57, 58,58,58,58, 58,58,58,58, 58,58,58,58, 59,60,61,54, 54,54,54,54, 54,54,54,54, 54,54,54,54 };
int TSpriteObject::ia_AnimMagic[4]={70,71,72,73};

TSpriteObject::TSpriteObject(PMAImageBank bank,TSpriteObject::Type t):TSpriteSpirits(bank)
{
    ib_got=false;
    itype=t;
    
    switch (t)
    {
        case T_SPHERE:
            setAnimSequence(ia_AnimSphere,4);
            ii_Retardo=8;
            break;
            
        case T_BOOK:
            setAnimSequence(ia_AnimBook,32);
            ii_Retardo=8;
            break;

        case T_MAGIC:
            setAnimSequence(ia_AnimMagic,4);
            ii_Retardo=6;
            break;
    }
}

bool TSpriteObject::draw(TMABitmap& g)
{
    PMABitmap bmp = io_images->getBitmap(ii_CurrentFotograma);
    PMABitmap bmp1 = io_images->getBitmap(69); // Atril

    int lw = bmp1->getWidth();
    int lh = bmp1->getHeight();
    
    #ifdef SMALL_GAME
        lw<<=1; lh<<=1;
    #endif
    
    // Dibujamos el atril.
    //
    int px = position.x + (position.width - lw)/2;
    int py = position.y + position.height - lh;
    if (!ib_got) g.drawSprite(bmp,position.x,position.y - lh,false,false);
    g.drawSprite(bmp1,px,py,false,false);

    return true;
}

void TSpriteObject::drawShadowed(TMABitmap& g,int ppx)
{
    PMABitmap bmp1 = bankShadow->getBitmap(69); // Atril

    int lw = bmp1->getWidth();
    int lh = bmp1->getHeight();

    #ifdef SMALL_GAME
        lw<<=1; lh<<=1;
    #endif
    
    // Dibujamos el atril.
    //
    int px = ppx + (position.width - lw)/2;
    int py = position.y + position.height - lh;

    if (!ib_got) 
    {
        PMABitmap lbmp = bankShadow->getBitmap(ii_CurrentFotograma);
        g.drawSprite(lbmp,ppx,position.y - lh,false,false);
    }
    g.drawSprite(bmp1,px,py,false,false);
}

void TSpriteObject::animate(void)
{
    if (!ib_got && (target->getScreenID()==screenID) && collisionsWith(*target) && GETKEYDOWN(K_TAKE))
    {
        ib_got=true;
        myGame->playSfx(sounds->snd_take);
        switch (itype)
        {
            case T_SPHERE:
                TSpiritsGame::msgQueue.putMessage(MSG_SPHERE_GOT);
                break;
            case T_BOOK:
                TSpiritsGame::msgQueue.putMessage(MSG_BOOK_GOT);
                break;
            case T_MAGIC:
                TSpiritsGame::msgQueue.putMessage(MSG_MAGIC_GOT);
                break;
        }
    }
    
 	if (ii_RetardoPos<ii_Retardo)
	{
		ii_RetardoPos ++;
	}
	else
	{
		ii_Frame = (ii_Frame<ii_AnimSequenceLength-1)?(ii_Frame+1):0;
		ii_RetardoPos=0;
	}
	TSpriteSpirits::animate();
}

void TSpriteObject::drawOnPanel(TMABitmap& g,int x,int y)
{
    PMABitmap lbmp = bankShadow->getBitmap(ii_CurrentFotograma);
    g.drawSprite(lbmp,x+5,y+5,false,false);
    g.drawSprite(io_images->getBitmap(ii_CurrentFotograma),x,y,false,false);
}

#undef GETKEY

#endif
