#ifndef _TMAMESSAGE_HPP_
#define _TMAMESSAGE_HPP_

#include "../ma_object.hpp"
#include "../tad/tmavector.hpp"

class TMAMsg;
class TMAMsgQueue;

typedef TMAMsg* PMAMsg;
typedef TMAMsgQueue *PMAMsgQueue;

// ************
// Clase TMAMsg
// ************
//
class TMAMsg : public TMAObject
{
    REGISTER_CLASS protected:

        friend class TMAMsgQueue;

        int msgid;
        void *source;
        void *param;
        
        TMAMsg();
        TMAMsg(int id,void *psource=0L,void *pparam=0L);

    public:
        PUBLIC_CLASS_ID;
        
        int getID() { return msgid; }
        void *getSource() { return source; }
        void *getParam() { return param; }
};

// *****************
// Clase TMAMsgQueue
// *****************
//
class TMAMsgQueue : public TMAObject
{
    REGISTER_CLASS protected:

        TMAVector<TMAMsg> msgqueue;
        static TMAMsg NULL_MSG;
        
    public:
        PUBLIC_CLASS_ID;
        
        void putMessage(int id,void *source=0L,void *param=0L);
        bool hasMessage(void);
        TMAMsg& getMessage(void);
        void dispatchMessage(void);
        int getMessageCount(void);
        void clearQueue(void);
};

#endif
