#ifndef _TMARECTANGLE_HPP_
#define _TMARECTANGLE_HPP_

#include "../ma_object.hpp"

class TMARectangle;
typedef TMARectangle* PMARectangle;

// ******************
// Clase TMARectangle
// ******************
//
class TMARectangle : public TMAObject
{
    REGISTER_CLASS protected:
        
    public:
        PUBLIC_CLASS_ID;
        int x,y;
        int width,height;
        
        TMARectangle();
        TMARectangle(int px,int py,int w,int h);
        TMARectangle(const TMARectangle& r);
        TMARectangle(int w, int h);
        TMARectangle& operator = (TMARectangle& r);
        TMARectangle& operator = (TMARectangle);
        
        void setBounds(TMARectangle& r);
        void setBounds(int px, int py, int pw, int ph);
        void setLocation(int px, int py);
        void translate(int px, int py);
        void setSize(int pw,int ph);
        bool contains(int px, int py);
        bool intersects(TMARectangle& r);
        TMARectangle intersection(TMARectangle& r);
        TMARectangle unionRect(TMARectangle& r);
        bool isEmpty();        
};

#endif
