#ifndef _TMASTRING_HPP_
#define _TMASTRING_HPP_

#include "../ma_object.hpp"

class TMAString;
typedef TMAString* PMAString;

// *****************************
// Clase que encapsula un String
// *****************************
//
class TMAString:public TMAObject
{
    REGISTER_CLASS private:

        static char *NULLSTR;
        char *c_str;
        long l_size;
        void init(void); // Inicializacin de la memoria.
        void free(void); // Libera la memoria reservada.
        void copyFrom(const char *);
        void assignChars(char *);
        
    public:
        PUBLIC_CLASS_ID;
        
       ~TMAString ();
        TMAString ();
        TMAString (const TMAString&); // Constructor de Copia por referencia.
        TMAString (const char *);
        
        long length(void) {return l_size;};
        long indexOf(const TMAString& substr,long fromindex=0);
        long indexOf(const char *substr,long fromindex=0);

        TMAString substring(long index,long nchars);
        TMAString substring(long index);
        TMAString trim(void);
        TMAString toUpperCase(void);
        TMAString toLowerCase(void);
        
        static TMAString valueOf(int num);
        static TMAString valueOf(long num);
        static TMAString valueOf(float num);
        static TMAString valueOf(double num);

        const int intValue(void);
        const long longValue(void);
        const float floatValue(void);
        const double doubleValue(void);

        int compare(const TMAString&);
        int compare(const char *str);
        bool isEqual(const char *str);
        bool isEqual(const TMAString& str);
        
        void replaceChar(char origen,char destino);
                
        const char* text(void)  {return c_str;};
        const char* operator *(void) {return c_str;};
        char charAt(long P) { return c_str[P];};
        char operator [](long P) {return c_str[P];};
        
        TMAString operator + (const char *);
        TMAString operator + (const TMAString&);
        
        TMAString& operator = (char *);
        TMAString& operator = (TMAString);
};

#endif
