#ifndef _TMASTRINGDICTIONARY_HPP_
#define _TMASTRINGDICTIONARY_HPP_

#include "../ma_object.hpp"
#include "../util/tmastring.hpp"
#include "../tad/tmavector.hpp"

class TMAStringDictionaryEntry : public TMAObject
{
    REGISTER_CLASS protected:

     public:
        PUBLIC_CLASS_ID;

        TMAString key;
        TMAString value;
};

// --- Comparador Entrada de Diccionario
//
class TMAStringDictionaryEntryComparator : public TMAItemComparator<TMAStringDictionaryEntry>
{     
    REGISTER_CLASS protected:

    public:
        PUBLIC_CLASS_ID;

        // Comparacin de dos objetos.
        // Retorna:
        //      -1 -> o1<o2
        //       0 -> o1=o2
        //       1 -> o1>o2
        //
        int compare(TMAStringDictionaryEntry& s1,TMAStringDictionaryEntry& s2) { return s1.key.compare(s2.key); }
};

// --- Comparador Entrada de Diccionario
//
class TMAStringDictionary : public TMAVectorOrdered<TMAStringDictionaryEntry>
{
    REGISTER_CLASS protected:

    public:
        PUBLIC_CLASS_ID;
        
        TMAStringDictionary();        
};

#endif
